library IEEE;                          
use IEEE.std_logic_1164.all;                          
use work.conv_pkg.all;                          
                          
entity ofdm_agc_mimo_opbw is                          
  generic (                          
    C_BASEADDR: std_logic_vector(0 to 31) := X"00000000";                          
    C_HIGHADDR: std_logic_vector(0 to 31) := X"0000FFFF";                          
    C_OPB_AWIDTH: integer := 32;                          
    C_OPB_DWIDTH: integer := 32                          
  );                          
  port (                          
    ce: in std_logic;                          
    i_in_a: in std_logic_vector(0 to 13);                          
    i_in_b: in std_logic_vector(0 to 13);                          
    opb_abus: in std_logic_vector(0 to 31);                          
    opb_be: in std_logic_vector(0 to 3);                          
    opb_clk: in std_logic;                          
    opb_dbus: in std_logic_vector(0 to 31);                          
    opb_rnw: in std_logic;                          
    opb_rst: in std_logic;                          
    opb_select: in std_logic;                          
    opb_seqaddr: in std_logic;                          
    packet_in: in std_logic;                          
    q_in_a: in std_logic_vector(0 to 13);                          
    q_in_b: in std_logic_vector(0 to 13);                          
    reset_in: in std_logic;                          
    rssi_in_a: in std_logic_vector(0 to 9);                          
    rssi_in_b: in std_logic_vector(0 to 9);                          
    done_a: out std_logic;                          
    done_b: out std_logic;                          
    g_bb_a: out std_logic_vector(0 to 4);                          
    g_bb_b: out std_logic_vector(0 to 4);                          
    g_rf_a: out std_logic_vector(0 to 1);                          
    g_rf_b: out std_logic_vector(0 to 1);                          
    i_out_a: out std_logic_vector(0 to 13);                          
    i_out_b: out std_logic_vector(0 to 13);                          
    q_out_a: out std_logic_vector(0 to 13);                          
    q_out_b: out std_logic_vector(0 to 13);                          
    rxhp_a: out std_logic;                          
    rxhp_b: out std_logic;                          
    sgp_dbus: out std_logic_vector(0 to 31);                          
    sgp_errack: out std_logic;                          
    sgp_retry: out std_logic;                          
    sgp_toutsup: out std_logic;                          
    sgp_xferack: out std_logic                          
  );                          
end ofdm_agc_mimo_opbw;                          
                          
architecture structural of ofdm_agc_mimo_opbw is                          
  signal ce_x0: std_logic;                          
  signal clk: std_logic;                          
  signal done_a_x0: std_logic;                          
  signal done_b_x0: std_logic;                          
  signal g_bb_a_x0: std_logic_vector(4 downto 0);                          
  signal g_bb_b_x0: std_logic_vector(4 downto 0);                          
  signal g_rf_a_x0: std_logic_vector(1 downto 0);                          
  signal g_rf_b_x0: std_logic_vector(1 downto 0);                          
  signal i_in_a_x0: std_logic_vector(13 downto 0);                          
  signal i_in_b_x0: std_logic_vector(13 downto 0);                          
  signal i_out_a_x0: std_logic_vector(13 downto 0);                          
  signal i_out_b_x0: std_logic_vector(13 downto 0);                          
  signal opb_abus_x0: std_logic_vector(31 downto 0);                          
  signal opb_be_x0: std_logic_vector(3 downto 0);                          
  signal opb_dbus_x0: std_logic_vector(31 downto 0);                          
  signal opb_rnw_x0: std_logic;                          
  signal opb_rst_x0: std_logic;                          
  signal opb_select_x0: std_logic;                          
  signal opb_seqaddr_x0: std_logic;                          
  signal packet_in_x0: std_logic;                          
  signal q_in_a_x0: std_logic_vector(13 downto 0);                          
  signal q_in_b_x0: std_logic_vector(13 downto 0);                          
  signal q_out_a_x0: std_logic_vector(13 downto 0);                          
  signal q_out_b_x0: std_logic_vector(13 downto 0);                          
  signal reset_in_x0: std_logic;                          
  signal rssi_in_a_x0: std_logic_vector(9 downto 0);                          
  signal rssi_in_b_x0: std_logic_vector(9 downto 0);                          
  signal rxhp_a_x0: std_logic;                          
  signal rxhp_b_x0: std_logic;                          
  signal sgp_dbus_x0: std_logic_vector(31 downto 0);                          
  signal sgp_errack_x0: std_logic;                          
  signal sgp_retry_x0: std_logic;                          
  signal sgp_toutsup_x0: std_logic;                          
  signal sgp_xferack_x0: std_logic;                          
                          
begin                          
  ce_x0 <= ce;                          
  i_in_a_x0 <= i_in_a;                          
  i_in_b_x0 <= i_in_b;                          
  opb_abus_x0 <= opb_abus xor C_BASEADDR;
  opb_be_x0 <= opb_be;                          
  clk <= opb_clk;                          
  opb_dbus_x0 <= opb_dbus;                          
  opb_rnw_x0 <= opb_rnw;                          
  opb_rst_x0 <= opb_rst;                          
  opb_select_x0 <= opb_select;                          
  opb_seqaddr_x0 <= opb_seqaddr;                          
  packet_in_x0 <= packet_in;                          
  q_in_a_x0 <= q_in_a;                          
  q_in_b_x0 <= q_in_b;                          
  reset_in_x0 <= reset_in;                          
  rssi_in_a_x0 <= rssi_in_a;                          
  rssi_in_b_x0 <= rssi_in_b;                          
  done_a <= done_a_x0;                          
  done_b <= done_b_x0;                          
  g_bb_a <= g_bb_a_x0;                          
  g_bb_b <= g_bb_b_x0;                          
  g_rf_a <= g_rf_a_x0;                          
  g_rf_b <= g_rf_b_x0;                          
  i_out_a <= i_out_a_x0;                          
  i_out_b <= i_out_b_x0;                          
  q_out_a <= q_out_a_x0;                          
  q_out_b <= q_out_b_x0;                          
  rxhp_a <= rxhp_a_x0;                          
  rxhp_b <= rxhp_b_x0;                          
  sgp_dbus <= sgp_dbus_x0;                          
  sgp_errack <= sgp_errack_x0;                          
  sgp_retry <= sgp_retry_x0;                          
  sgp_toutsup <= sgp_toutsup_x0;                          
  sgp_xferack <= sgp_xferack_x0;                          
                          
  sysgen_dut: entity work.ofdm_agc_mimo_cw                          
    port map (                          
      ce => ce_x0,                          
      clk => clk,                          
      i_in_a => i_in_a_x0,                          
      i_in_b => i_in_b_x0,                          
      opb_abus => opb_abus_x0,                          
      opb_be => opb_be_x0,                          
      opb_dbus => opb_dbus_x0,                          
      opb_rnw => opb_rnw_x0,                          
      opb_rst => opb_rst_x0,                          
      opb_select => opb_select_x0,                          
      opb_seqaddr => opb_seqaddr_x0,                          
      packet_in => packet_in_x0,                          
      q_in_a => q_in_a_x0,                          
      q_in_b => q_in_b_x0,                          
      reset_in => reset_in_x0,                          
      rssi_in_a => rssi_in_a_x0,                          
      rssi_in_b => rssi_in_b_x0,                          
      done_a => done_a_x0,                          
      done_b => done_b_x0,                          
      g_bb_a => g_bb_a_x0,                          
      g_bb_b => g_bb_b_x0,                          
      g_rf_a => g_rf_a_x0,                          
      g_rf_b => g_rf_b_x0,                          
      i_out_a => i_out_a_x0,                          
      i_out_b => i_out_b_x0,                          
      q_out_a => q_out_a_x0,                          
      q_out_b => q_out_b_x0,                          
      rxhp_a => rxhp_a_x0,                          
      rxhp_b => rxhp_b_x0,                          
      sgp_dbus => sgp_dbus_x0,                          
      sgp_errack => sgp_errack_x0,                          
      sgp_retry => sgp_retry_x0,                          
      sgp_toutsup => sgp_toutsup_x0,                          
      sgp_xferack => sgp_xferack_x0                          
    );                          
                          
end structural;                          
