#################################################################
# Makefile generated by Xilinx Platform Studio 
# Project:C:\workshop_prep\Lab4to6_MAC\xps\system.xmp
#
# WARNING : This file will be re-generated every time a command
# to run a make target is invoked. So, any changes made to this  
# file manually, will be lost when make is invoked next. 
#################################################################

# Name of the Microprocessor system
# The hardware specification of the system is in file :
# C:\workshop_prep\Lab4to6_MAC\xps\system.mhs
# The software specification of the system is in file :
# C:\workshop_prep\Lab4to6_MAC\xps\system.mss

include system_incl.make

#################################################################
# PHONY TARGETS
#################################################################
.PHONY: dummy
.PHONY: netlistclean
.PHONY: bitsclean
.PHONY: simclean
.PHONY: vpclean

#################################################################
# EXTERNAL TARGETS
#################################################################
all:
	@echo "Makefile to build a Microprocessor system :"
	@echo "Run make with any of the following targets"
	@echo " "
	@echo "  netlist  : Generates the netlist for the given MHS "
	@echo "  bits     : Runs Implementation tools to generate the bitstream"
	@echo "  exporttopn:Export to ProjNav"
	@echo " "
	@echo "  libs     : Configures the sw libraries for this system"
	@echo "  program  : Compiles the program sources for all the processor instances"
	@echo " "
	@echo "  init_bram: Initializes bitstream with BRAM data"
	@echo "  ace      : Generate ace file from bitstream and elf"
	@echo "  download : Downloads the bitstream onto the board"
	@echo " "
	@echo "  sim      : Generates HDL simulation models and runs simulator for chosen simulation mode"
	@echo "  simmodel : Generates HDL simulation models for chosen simulation mode"
	@echo "  behavioral_model : Generates behavioral HDL models with BRAM initialization"
	@echo "  structural_model : Generates structural simulation HDL models with BRAM initialization"
	@echo "  timing   : Generates timing simulation HDL models with BRAM initialization"
	@echo "  vp       : Generates virtual platform model"
	@echo " "
	@echo "  netlistclean: Deletes netlist"
	@echo "  bitsclean: Deletes bit, ncd, bmm files"
	@echo "  hwclean  : Deletes implementation dir"
	@echo "  libsclean: Deletes sw libraries"
	@echo "  programclean: Deletes compiled ELF files"
	@echo "  swclean  : Deletes sw libraries and ELF files"
	@echo "  simclean : Deletes simulation dir"
	@echo "  vpclean  : Deletes virtualplatform dir"
	@echo "  clean    : Deletes all generated files/directories"
	@echo " "
	@echo "  make <target> : (Default)"
	@echo "      Creates a Microprocessor system using default initializations"
	@echo "      specified for each processor in MSS file"


bits: $(SYSTEM_BIT)

ace: $(SYSTEM_ACE)

netlist: $(POSTSYN_NETLIST)

libs: $(LIBRARIES)

program: $(ALL_USER_ELF_FILES)

download: $(DOWNLOAD_BIT) dummy
	@echo "*********************************************"
	@echo "Downloading Bitstream onto the target board"
	@echo "*********************************************"
	impact -batch etc/download.cmd

init_bram: $(DOWNLOAD_BIT)

sim: $(DEFAULT_SIM_SCRIPT)
	cd simulation/behavioral; \
	$(SIM_CMD)  &

simmodel: $(DEFAULT_SIM_SCRIPT)

behavioral_model: $(BEHAVIORAL_SIM_SCRIPT)

structural_model: $(STRUCTURAL_SIM_SCRIPT)

vp: $(VPEXEC)

clean: hwclean libsclean programclean simclean vpclean
	rm -f _impact.cmd
	rm -f *.log

hwclean: netlistclean bitsclean
	rm -rf implementation synthesis xst hdl
	rm -rf xst.srp $(SYSTEM).srp

netlistclean:
	rm -f $(POSTSYN_NETLIST)
	rm -f platgen.log
	rm -f $(BMM_FILE)

bitsclean:
	rm -f $(SYSTEM_BIT)
	rm -f implementation/$(SYSTEM).ncd
	rm -f implementation/$(SYSTEM)_bd.bmm 

bitsclean:

simclean: 
	rm -rf simulation/behavioral
	rm -f simgen.log

swclean: libsclean programclean
	@echo ""

libsclean: $(LIBSCLEAN_TARGETS)
	rm -f libgen.log

programclean: $(PROGRAMCLEAN_TARGETS)

vpclean:
	rm -rf virtualplatform
	rm -f vpgen.log

#################################################################
# SOFTWARE PLATFORM FLOW
#################################################################


$(LIBRARIES): $(MHSFILE) $(MSSFILE) __xps/libgen.opt
	@echo "*********************************************"
	@echo "Creating software libraries..."
	@echo "*********************************************"
	libgen $(LIBGEN_OPTIONS) $(MSSFILE)


ppc405_0_libsclean:
	rm -rf ppc405_0/lib/

ppc405_1_libsclean:
	rm -rf ppc405_1/lib/

#################################################################
# SOFTWARE APPLICATION CSMA_MAC
#################################################################

CSMA_MAC_program: $(CSMA_MAC_OUTPUT) 

$(CSMA_MAC_OUTPUT) : $(CSMA_MAC_SOURCES) $(CSMA_MAC_HEADERS) $(CSMA_MAC_LINKER_SCRIPT) \
                    $(LIBRARIES) __xps/csma_mac_compiler.opt
	@mkdir -p $(CSMA_MAC_OUTPUT_DIR) 
	$(CSMA_MAC_CC) $(CSMA_MAC_CC_OPT) $(CSMA_MAC_SOURCES) -o $(CSMA_MAC_OUTPUT) \
	$(CSMA_MAC_OTHER_CC_FLAGS) $(CSMA_MAC_INCLUDES) $(CSMA_MAC_LIBPATH) \
	$(CSMA_MAC_CFLAGS) $(CSMA_MAC_LFLAGS) 
	$(CSMA_MAC_CC_SIZE) $(CSMA_MAC_OUTPUT) 
	@echo ""

CSMA_MAC_programclean:
	rm -f $(CSMA_MAC_OUTPUT) 

#################################################################
# SOFTWARE APPLICATION NOMAC
#################################################################

NOMAC_program: $(NOMAC_OUTPUT) 

$(NOMAC_OUTPUT) : $(NOMAC_SOURCES) $(NOMAC_HEADERS) $(NOMAC_LINKER_SCRIPT) \
                    $(LIBRARIES) __xps/nomac_compiler.opt
	@mkdir -p $(NOMAC_OUTPUT_DIR) 
	$(NOMAC_CC) $(NOMAC_CC_OPT) $(NOMAC_SOURCES) -o $(NOMAC_OUTPUT) \
	$(NOMAC_OTHER_CC_FLAGS) $(NOMAC_INCLUDES) $(NOMAC_LIBPATH) \
	$(NOMAC_CFLAGS) $(NOMAC_LFLAGS) 
	$(NOMAC_CC_SIZE) $(NOMAC_OUTPUT) 
	@echo ""

NOMAC_programclean:
	rm -f $(NOMAC_OUTPUT) 

#################################################################
# SOFTWARE APPLICATION UNIMAC_SERVER
#################################################################

UNIMAC_SERVER_program: $(UNIMAC_SERVER_OUTPUT) 

$(UNIMAC_SERVER_OUTPUT) : $(UNIMAC_SERVER_SOURCES) $(UNIMAC_SERVER_HEADERS) $(UNIMAC_SERVER_LINKER_SCRIPT) \
                    $(LIBRARIES) __xps/unimac_server_compiler.opt
	@mkdir -p $(UNIMAC_SERVER_OUTPUT_DIR) 
	$(UNIMAC_SERVER_CC) $(UNIMAC_SERVER_CC_OPT) $(UNIMAC_SERVER_SOURCES) -o $(UNIMAC_SERVER_OUTPUT) \
	$(UNIMAC_SERVER_OTHER_CC_FLAGS) $(UNIMAC_SERVER_INCLUDES) $(UNIMAC_SERVER_LIBPATH) \
	$(UNIMAC_SERVER_CFLAGS) $(UNIMAC_SERVER_LFLAGS) 
	$(UNIMAC_SERVER_CC_SIZE) $(UNIMAC_SERVER_OUTPUT) 
	@echo ""

UNIMAC_SERVER_programclean:
	rm -f $(UNIMAC_SERVER_OUTPUT) 

#################################################################
# SOFTWARE APPLICATION UNIMAC_CLIENT
#################################################################

UNIMAC_CLIENT_program: $(UNIMAC_CLIENT_OUTPUT) 

$(UNIMAC_CLIENT_OUTPUT) : $(UNIMAC_CLIENT_SOURCES) $(UNIMAC_CLIENT_HEADERS) $(UNIMAC_CLIENT_LINKER_SCRIPT) \
                    $(LIBRARIES) __xps/unimac_client_compiler.opt
	@mkdir -p $(UNIMAC_CLIENT_OUTPUT_DIR) 
	$(UNIMAC_CLIENT_CC) $(UNIMAC_CLIENT_CC_OPT) $(UNIMAC_CLIENT_SOURCES) -o $(UNIMAC_CLIENT_OUTPUT) \
	$(UNIMAC_CLIENT_OTHER_CC_FLAGS) $(UNIMAC_CLIENT_INCLUDES) $(UNIMAC_CLIENT_LIBPATH) \
	$(UNIMAC_CLIENT_CFLAGS) $(UNIMAC_CLIENT_LFLAGS) 
	$(UNIMAC_CLIENT_CC_SIZE) $(UNIMAC_CLIENT_OUTPUT) 
	@echo ""

UNIMAC_CLIENT_programclean:
	rm -f $(UNIMAC_CLIENT_OUTPUT) 

#################################################################
# SOFTWARE APPLICATION HOPMAC_SERVER
#################################################################

HOPMAC_SERVER_program: $(HOPMAC_SERVER_OUTPUT) 

$(HOPMAC_SERVER_OUTPUT) : $(HOPMAC_SERVER_SOURCES) $(HOPMAC_SERVER_HEADERS) $(HOPMAC_SERVER_LINKER_SCRIPT) \
                    $(LIBRARIES) __xps/hopmac_server_compiler.opt
	@mkdir -p $(HOPMAC_SERVER_OUTPUT_DIR) 
	$(HOPMAC_SERVER_CC) $(HOPMAC_SERVER_CC_OPT) $(HOPMAC_SERVER_SOURCES) -o $(HOPMAC_SERVER_OUTPUT) \
	$(HOPMAC_SERVER_OTHER_CC_FLAGS) $(HOPMAC_SERVER_INCLUDES) $(HOPMAC_SERVER_LIBPATH) \
	$(HOPMAC_SERVER_CFLAGS) $(HOPMAC_SERVER_LFLAGS) 
	$(HOPMAC_SERVER_CC_SIZE) $(HOPMAC_SERVER_OUTPUT) 
	@echo ""

HOPMAC_SERVER_programclean:
	rm -f $(HOPMAC_SERVER_OUTPUT) 

#################################################################
# SOFTWARE APPLICATION HOPMAC_CLIENT
#################################################################

HOPMAC_CLIENT_program: $(HOPMAC_CLIENT_OUTPUT) 

$(HOPMAC_CLIENT_OUTPUT) : $(HOPMAC_CLIENT_SOURCES) $(HOPMAC_CLIENT_HEADERS) $(HOPMAC_CLIENT_LINKER_SCRIPT) \
                    $(LIBRARIES) __xps/hopmac_client_compiler.opt
	@mkdir -p $(HOPMAC_CLIENT_OUTPUT_DIR) 
	$(HOPMAC_CLIENT_CC) $(HOPMAC_CLIENT_CC_OPT) $(HOPMAC_CLIENT_SOURCES) -o $(HOPMAC_CLIENT_OUTPUT) \
	$(HOPMAC_CLIENT_OTHER_CC_FLAGS) $(HOPMAC_CLIENT_INCLUDES) $(HOPMAC_CLIENT_LIBPATH) \
	$(HOPMAC_CLIENT_CFLAGS) $(HOPMAC_CLIENT_LFLAGS) 
	$(HOPMAC_CLIENT_CC_SIZE) $(HOPMAC_CLIENT_OUTPUT) 
	@echo ""

HOPMAC_CLIENT_programclean:
	rm -f $(HOPMAC_CLIENT_OUTPUT) 

#################################################################
# BOOTLOOP ELF FILES
#################################################################



$(PPC405_0_BOOTLOOP): $(PPC405_BOOTLOOP)
	@mkdir -p $(BOOTLOOP_DIR)
	cp -f $(PPC405_BOOTLOOP) $(PPC405_0_BOOTLOOP)

$(PPC405_1_BOOTLOOP): $(PPC405_BOOTLOOP)
	@mkdir -p $(BOOTLOOP_DIR)
	cp -f $(PPC405_BOOTLOOP) $(PPC405_1_BOOTLOOP)

#################################################################
# HARDWARE IMPLEMENTATION FLOW
#################################################################


$(BMM_FILE) \
$(WRAPPER_NGC_FILES): $(MHSFILE) __xps/platgen.opt \
                      $(CORE_STATE_DEVELOPMENT_FILES)
	@echo "****************************************************"
	@echo "Creating system netlist for hardware specification.."
	@echo "****************************************************"
	platgen $(PLATGEN_OPTIONS) $(MHSFILE)

$(POSTSYN_NETLIST): $(WRAPPER_NGC_FILES)
	@echo "Running synthesis..."
	bash -c "cd synthesis; ./synthesis.sh"

$(SYSTEM_BIT): $(FPGA_IMP_DEPENDENCY)
	@echo "*********************************************"
	@echo "Running Xilinx Implementation tools.."
	@echo "*********************************************"
	@cp -f $(UCF_FILE) implementation/$(SYSTEM).ucf
	@cp -f $(XFLOW_OPT_FILE) implementation/xflow.opt
	xflow -wd implementation -p $(DEVICE) -implement xflow.opt $(SYSTEM).ngc
	@echo "*********************************************"
	@echo "Running Bitgen.."
	@echo "*********************************************"
	@cp -f $(BITGEN_UT_FILE) implementation/bitgen.ut
	cd implementation; bitgen -w -f bitgen.ut $(SYSTEM)

exporttopn: 
	@echo "You have chosen XPS for implementation tool flow."
	@echo "Please select ProjNav as your implementation flow in Project Options."
	@echo "In batch mode, use command 'xset pnproj <nplfile>'."

$(DOWNLOAD_BIT): $(SYSTEM_BIT) $(BRAMINIT_ELF_FILES) __xps/bitinit.opt
	@cp -f implementation/$(SYSTEM)_bd.bmm .
	@echo "*********************************************"
	@echo "Initializing BRAM contents of the bitstream"
	@echo "*********************************************"
	bitinit $(MHSFILE) $(SEARCHPATHOPT) $(BRAMINIT_ELF_FILE_ARGS) \
	-bt $(SYSTEM_BIT) -o $(DOWNLOAD_BIT)
	@rm -f $(SYSTEM)_bd.bmm

$(SYSTEM_ACE):
	@echo "In order to generate ace file, you must have:-"
	@echo "- exactly one processor."
	@echo "- opb_mdm, if using microblaze."

#################################################################
# SIMULATION FLOW
#################################################################


################## BEHAVIORAL SIMULATION ##################

$(BEHAVIORAL_SIM_SCRIPT): $(MHSFILE) __xps/simgen.opt \
                          $(BRAMINIT_ELF_FILES)
	@echo "*********************************************"
	@echo "Creating behavioral simulation models..."
	@echo "*********************************************"
	simgen $(SIMGEN_OPTIONS) -m behavioral $(MHSFILE)

################## STRUCTURAL SIMULATION ##################

$(STRUCTURAL_SIM_SCRIPT): $(WRAPPER_NGC_FILES) __xps/simgen.opt \
                          $(BRAMINIT_ELF_FILES)
	@echo "*********************************************"
	@echo "Creating structural simulation models..."
	@echo "*********************************************"
	simgen $(SIMGEN_OPTIONS) -sd implementation -m structural $(MHSFILE)


################## TIMING SIMULATION ##################

$(TIMING_SIM_SCRIPT): $(SYSTEM_BIT) __xps/simgen.opt \
                      $(BRAMINIT_ELF_FILES)
	@echo "*********************************************"
	@echo "Creating timing simulation models..."
	@echo "*********************************************"
	simgen $(SIMGEN_OPTIONS) -sd implementation -m timing $(MHSFILE)

#################################################################
# VIRTUAL PLATFORM FLOW
#################################################################


$(VPEXEC): $(MHSFILE) __xps/vpgen.opt
	@echo "****************************************************"
	@echo "Creating virtual platform for hardware specification.."
	@echo "****************************************************"
	vpgen $(VPGEN_OPTIONS) $(MHSFILE)

dummy:
	@echo ""

